/******************************************************************************
 *
 * (c) Copyright 2015 BelBoard, Inc. All rights reserved.
 *
 * This file contains confidential and proprietary information of BelBoard, Inc.
 * and is protected under BY Reports and international copyright and other
 * intellectual property laws.
 * THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE
 * AT ALL TIMES.
 *
 ******************************************************************************/
/*****************************************************************************/
/**
 * check it out for kettenrad
 * by rudi ;-)  2015
 * @file    user_config.h
 * @version v1.00a
 * @date    06.04.2015
 * @brief   Start Main.
 *
 * MODIFICATION HISTORY:
 *
 * Ver   Who      Date        Changes
 * ----- -------- ----------  -----------------------------------------------
 * 1.00a mlx     06/04/2015  First release
 *
 *
 ******************************************************************************/
/****************************** Include Files *******************************/
#include "ets_sys.h"
#include "osapi.h"
#include "os_type.h"
#include "user_interface.h"
#include "driver/uart.h"

#include "espconn.h"
#include "mem.h"
#include "gpio.h"

#include "../include/driver/diskio.h"
#include "../include/driver/ff.h"
#include "driver/spi.h"
#include "driver/spi_register.h"

#include "driver/diskio.h"
#include "driver/ff.h"

/************************** Constant Definitions ****************************/

/**************************** Type Definitions ******************************/
/***************** Macros (Inline Functions) Definitions ********************/
/************************** Variable Definitions ****************************/



static volatile os_timer_t sd_timer;



//Timer event.
static void ICACHE_FLASH_ATTR
mysdTimer(void *arg) {
	//100Hz timer
	disk_timerproc();
	os_timer_setfn(&sd_timer, (os_timer_func_t *) mysdTimer, NULL);
	os_timer_arm(&sd_timer, 10, 0);
}

void user_rf_pre_init()
{

}

// http://elm-chan.org/fsw/ff/en/readdir.html
FRESULT ICACHE_FLASH_ATTR scan_files (
    char* path        /* Start node to be scanned (also used as work area) */
)
{
    FRESULT res;
    FILINFO fno;
    DIR dir;
    int i;
    char *fn;   /* This function assumes non-Unicode configuration */
#if _USE_LFN
    static char lfn[_MAX_LFN + 1];   /* Buffer to store the LFN */
    fno.lfname = lfn;
    fno.lfsize = sizeof lfn;
#endif


    res = f_opendir(&dir, path);                       /* Open the directory */
    if (res == FR_OK) {
        i = strlen(path);
        for (;;) {
            res = f_readdir(&dir, &fno);                   /* Read a directory item */
            if (res != FR_OK || fno.fname[0] == 0) break;  /* Break on error or end of dir */
            if (fno.fname[0] == '.') continue;             /* Ignore dot entry */
#if _USE_LFN
            fn = *fno.lfname ? fno.lfname : fno.fname;
#else
            fn = fno.fname;
#endif
            if (fno.fattrib & AM_DIR) {                    /* It is a directory */
                os_sprintf(&path[i], "/%s", fn);
                res = scan_files(path);
                path[i] = 0;
                if (res != FR_OK) break;
            } else {                                       /* It is a file. */
                os_printf("%s/%s\n", path, fn);
            }
        }
        f_closedir(&dir);
    }

    return res;
}


void ICACHE_FLASH_ATTR
user_init() {
	FRESULT res;
	FATFS FATFS_Obj;
	FIL Fil;
	UINT bw;


	// Configure the UART
	uart_init(BIT_RATE_115200, 0);
	// Enable system messages
	system_set_os_print(1);
	os_printf("\n\n");


	ETS_UART_INTR_DISABLE();
	wifi_set_opmode(NULL_MODE);	//disable wifi
	ETS_UART_INTR_ENABLE();

	os_printf("WIFI SET UP IN NULL MODE \n\r");

	os_timer_disarm(&sd_timer);
	os_timer_setfn(&sd_timer, (os_timer_func_t *) mysdTimer, NULL);
	os_timer_arm(&sd_timer, 10, 0);

	os_printf("START SYSTEM \n\r");
	spi_init();
	os_printf("INIT SPI OK  \n\r");


	DSTATUS stinit = disk_initialize(0);

	if (stinit) {
		if (stinit == RES_ERROR) {
			os_printf("R/W ERROR \n\r");
			return;
		}
		if (stinit == RES_WRPRT) {
			os_printf("Write Protected \n\r");
			return;
		}
		if (stinit == RES_NOTRDY) {
			os_printf("Not Ready \n\r");
			return;
		}
		if (stinit == RES_PARERR) {
			os_printf("Invalid Parameter \n\r");
			return;
		}
	}
	os_printf("SD interface init OK \n\r");

	res = f_mount(&FATFS_Obj, "", 0);
	if (res == FR_OK)
		os_printf("Mounted OK \n\r");
	else
		os_printf("Fat mount ERROR %d \n\r", (int) res);



	res = scan_files("");
	if (res == FR_OK)
		os_printf("\n\r Scan files  OK \n\r");
	else
		os_printf("Scan files ERROR %d \n\r", (int) res);


	// change with variable
	uint8_t hellokettenrad[]="done by rudi ;-)\r\n";

	/* now we create a file: */
	os_printf("write test: \r\n");
	if (f_open(&Fil, "32_done.txt", FA_WRITE | FA_CREATE_ALWAYS) == FR_OK){
	//	f_write(&Fil, "Done by rudi ;-)\r\n", 11, &bw);
	//	f_write(&Fil, "Done by rudi ;-)\r\n", (strlen("Done by rudi ;-)") + 2), &bw);
		f_write(&Fil, hellokettenrad, (strlen(hellokettenrad)) , &bw);
		f_close(&Fil);

	//	if (bw == (strlen("Done by rudi ;-)") + 2)) {
	//  change in variable
		if (bw == strlen(hellokettenrad)) {
		os_printf("write ok\r\n");
		}

	}


	/* now we read the text file and prompt it to uart */
	char line[82];	/*line buffer */
	FRESULT fr;		/*FatFs return code */

	os_printf("read the file: \r\n");

	/* open a text file */
	fr = f_open(&Fil, "32_done.txt", FA_READ);
	// if (fr) return (int)fr;

	/* read all lines and display it */
	 while (f_gets(line, sizeof(line), &Fil))
	//f_gets(line, sizeof line,&Fil);

	os_printf(line);

	/* close the file */
	f_close(&Fil);

	// return 0;

}
